#!/bin/sh

awk '
# Modify X and Y to make a nicer map.  We turn the map upside down (since 
# North and South are relative and can be flipped) 
# Input: A Civilization IV map (WorldBuilderSave) file
# Output: The same file with the map turned upside down

# We dont actually know the size; this script is hard-coded for extra-huge
# PerfectWorld maps
function Xm(x) {if(x >= 43 && x <= 118){return x - 43}else{return -1}} 
function Ym(y) {if(y >= 13 && y <= 72){return y - 13}else{return -1}} 

{
# Starting locations
if(/StartingX=([0-9]+), StartingY=([0-9]+)/) {
        x=$0;
        sub(/.*StartingX=/,"",x);sub(/,.*/,"",x);
        y=$0;sub(/.*StartingY=/,"",y);
        x = Xm(x);y = Ym(y);
        $0 = "\tStartingX=" x ", StartingY=" y
        }
# Map tiles
if(/x=([0-9]+),y=([0-9]+)/) {
        x=$0;
        sub(/.*x=/,"",x);sub(/,.*/,"",x);
        y=$0;sub(/.*y=/,"",y);
        x = Xm(x);y = Ym(y);
        $0 = "\tx=" x ",y=" y
        }
# Print modified map
print
}'         
